(** File generated by coq-of-ocaml *)
Require Import CoqOfOCaml.CoqOfOCaml.
Require Import CoqOfOCaml.Settings.

Require Import TezosOfOCaml.Proto_alpha.Environment.
Require TezosOfOCaml.Proto_alpha.Alpha_context.
Require TezosOfOCaml.Proto_alpha.Script_ir_translator.
Require TezosOfOCaml.Proto_alpha.Script_typed_ir.
Require TezosOfOCaml.Proto_alpha.Ticket_balance_key.
Require TezosOfOCaml.Proto_alpha.Ticket_scanner.
Require TezosOfOCaml.Proto_alpha.Ticket_token.

Definition add_ticket_balance
  (contract : Alpha_context.Contract.t) (ctxt : Alpha_context.context)
  (ticket : Ticket_scanner.ex_ticket) : M? Alpha_context.context :=
  let '(token, amount) := Ticket_token.token_and_amount_of_ex_ticket ticket in
  let? '(hash_value, ctxt) :=
    Ticket_balance_key.ticket_balance_key ctxt contract token in
  let? '(_added_size, ctxt) :=
    Alpha_context.Ticket_balance.adjust_balance ctxt hash_value
      (Alpha_context.Script_int.to_zint amount) in
  return? ctxt.

Definition update_contract_tickets
  (ctxt : Alpha_context.context) (contract : Alpha_context.Contract.contract)
  : M? Alpha_context.context :=
  let? '(ctxt, script) := Alpha_context.Contract.get_script ctxt contract in
  match script with
  | None => return? ctxt
  | Some script =>
    let? '(ex_script, ctxt) :=
      Script_ir_translator.parse_script None ctxt true true script in
    let
      'Script_ir_translator.Ex_script {|
        Script_typed_ir.script.storage := storage_value;
          Script_typed_ir.script.storage_type := storage_type
          |} := ex_script in
    let? '(has_tickets_value, ctxt) :=
      Ticket_scanner.type_has_tickets ctxt storage_type in
    let? '(tickets, ctxt) :=
      Ticket_scanner.tickets_of_value ctxt true has_tickets_value storage_value
      in
    List.fold_left_es (add_ticket_balance contract) ctxt tickets
  end.

Definition is_originated (contract : Alpha_context.Contract.contract) : bool :=
  match Alpha_context.Contract.is_originated contract with
  | Some _ => true
  | _ => false
  end.

Definition init_value (ctxt : Alpha_context.context)
  : M? Alpha_context.context :=
  let contracts := Alpha_context.Contract.list_value ctxt in
  let contracts := List.filter is_originated contracts in
  List.fold_left_es update_contract_tickets ctxt contracts.
